import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group } from 'three';
import * as i0 from "@angular/core";
export interface NgtsBillboardOptions extends Partial<NgtGroup> {
    follow?: boolean;
    lockX?: boolean;
    lockY?: boolean;
    lockZ?: boolean;
}
export declare class NgtsBillboard {
    options: import("@angular/core").InputSignalWithTransform<NgtsBillboardOptions, "" | Partial<NgtsBillboardOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsBillboardOptions, "follow" | "lockX" | "lockY" | "lockZ">>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    innerRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsBillboard, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsBillboard, "ngts-billboard", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
