import { ElementRef, Injector } from '@angular/core';
import { Object3D } from 'three';
import * as i0 from "@angular/core";
type HelperArgs<T> = T extends [infer _, ...infer R] ? R : never;
export declare function injectHelper<TConstructor extends new (...args: any[]) => Object3D, THelperInstance extends InstanceType<TConstructor> & {
    update: () => void;
    dispose: () => void;
}>(object: () => ElementRef<Object3D> | Object3D | undefined | null, helperConstructor: () => TConstructor, { injector, args, }?: {
    injector?: Injector;
    args?: () => HelperArgs<ConstructorParameters<TConstructor>>;
}): import("@angular/core").Signal<THelperInstance | null>;
export declare class NgtsHelper<TConstructor extends new (...args: any[]) => Object3D> {
    type: import("@angular/core").InputSignal<TConstructor>;
    options: import("@angular/core").InputSignal<HelperArgs<ConstructorParameters<TConstructor>>>;
    helperRef: import("@angular/core").Signal<ElementRef<Object3D<import("three").Object3DEventMap>>>;
    private parent;
    helper: import("@angular/core").Signal<(InstanceType<TConstructor> & {
        update: () => void;
        dispose: () => void;
    }) | null>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsHelper<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsHelper<any>, "ngts-helper", never, { "type": { "alias": "type"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export {};
