import { Signal, TemplateRef } from '@angular/core';
import { Object3D, Scene, Vector3 } from 'three';
import * as i0 from "@angular/core";
export declare class NgtsGizmoHelperContent {
    static ngTemplateContextGuard(_: NgtsGizmoHelperContent, ctx: unknown): ctx is {
        container: Object3D;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsGizmoHelperContent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsGizmoHelperContent, "ng-template[gizmoHelperContent]", never, {}, {}, never, never, true, never>;
}
export interface NgtsGizmoHelperOptions {
    alignment: 'top-left' | 'top-right' | 'bottom-right' | 'bottom-left' | 'bottom-center' | 'center-right' | 'center-left' | 'center-center' | 'top-center';
    margin: [number, number];
    renderPriority: number;
    autoClear?: boolean;
}
export declare class NgtsGizmoHelper {
    options: import("@angular/core").InputSignalWithTransform<NgtsGizmoHelperOptions, "" | Partial<NgtsGizmoHelperOptions>>;
    update: import("@angular/core").OutputEmitterRef<void>;
    protected renderPriority: Signal<number>;
    protected margin: Signal<[number, number]>;
    protected alignment: Signal<"top-left" | "top-right" | "bottom-right" | "bottom-left" | "bottom-center" | "center-right" | "center-left" | "center-center" | "top-center">;
    protected scene: Scene;
    protected content: Signal<TemplateRef<any>>;
    private gizmoRef;
    private virtualCameraRef;
    private store;
    private size;
    private mainCamera;
    private defaultControls;
    private invalidate;
    protected x: Signal<number>;
    protected y: Signal<number>;
    private animating;
    private radius;
    private focusPoint;
    private defaultUp;
    constructor();
    tweenCamera(direction: Vector3): void;
    private updateDefaultUpEffect;
    private isOrbitControls;
    private isCameraControls;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsGizmoHelper, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsGizmoHelper, "ngts-gizmo-helper", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "update": "update"; }, ["content"], never, true, never>;
}
