import { ElementRef, Signal } from '@angular/core';
import { NgtThreeEvent } from 'angular-three';
import { Group, Matrix4, Vector3 } from 'three';
import { NgtsPivotControls } from './pivot-controls';
import * as i0 from "@angular/core";
export declare class NgtsAxisRotator {
    protected readonly DoubleSide: 2;
    dir1: import("@angular/core").InputSignal<Vector3>;
    dir2: import("@angular/core").InputSignal<Vector3>;
    axis: import("@angular/core").InputSignal<0 | 1 | 2>;
    groupRef: Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    annotationRef: Signal<ElementRef<HTMLDivElement> | undefined>;
    pivotControls: NgtsPivotControls;
    private store;
    private controls;
    hovered: import("@angular/core").WritableSignal<boolean>;
    private angle;
    private angle0;
    private clickInfo;
    matrixL: Signal<Matrix4>;
    r: Signal<number>;
    arc: Signal<Vector3[]>;
    constructor();
    onPointerDown(event: NgtThreeEvent<PointerEvent>): void;
    onPointerMove(event: NgtThreeEvent<PointerEvent>): void;
    onPointerUp(event: NgtThreeEvent<PointerEvent>): void;
    onPointerOut(event: NgtThreeEvent<PointerEvent>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsAxisRotator, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsAxisRotator, "ngts-axis-rotator", never, { "dir1": { "alias": "dir1"; "required": true; "isSignal": true; }; "dir2": { "alias": "dir2"; "required": true; "isSignal": true; }; "axis": { "alias": "axis"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
