import { ElementRef } from '@angular/core';
import * as i0 from "@angular/core";
export interface NgtsLoaderOptions {
    containerClass?: string;
    innerClass?: string;
    barClass?: string;
    dataClass?: string;
    dataInterpolation: (value: number) => string;
    initialState: (value: boolean) => boolean;
}
export declare class NgtsLoader {
    private progressState;
    active: import("@angular/core").Signal<boolean>;
    progress: import("@angular/core").Signal<number>;
    options: import("@angular/core").InputSignalWithTransform<NgtsLoaderOptions, "" | Partial<NgtsLoaderOptions>>;
    containerClass: import("@angular/core").Signal<string | undefined>;
    innerClass: import("@angular/core").Signal<string | undefined>;
    barClass: import("@angular/core").Signal<string | undefined>;
    dataClass: import("@angular/core").Signal<string | undefined>;
    initialState: import("@angular/core").Signal<(value: boolean) => boolean>;
    dataInterpolation: import("@angular/core").Signal<(value: number) => string>;
    progressSpanRef: import("@angular/core").Signal<ElementRef<HTMLSpanElement> | undefined>;
    shown: import("@angular/core").WritableSignal<boolean>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsLoader, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsLoader, "ngts-loader", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
