import { Injector, Signal } from '@angular/core';
import { NgtLoaderResults } from 'angular-three';
import { Texture } from 'three';
declare function _injectTexture<TInput extends string[] | string | Record<string, string>>(input: () => TInput, { onLoad, injector }?: {
    onLoad?: (texture: Texture[]) => void;
    injector?: Injector;
}): Signal<NgtLoaderResults<TInput, Texture> | null>;
declare namespace _injectTexture {
    var preload: <TInput extends string[] | string | Record<string, string>>(input: () => TInput) => void;
}
export type NgtsTextureLoader = typeof _injectTexture;
export declare const injectTexture: NgtsTextureLoader;
export {};
