import { NgtAttachable, NgtMeshPhysicalMaterial } from 'angular-three';
import { MeshDistortMaterial, MeshDistortMaterialParameters } from 'angular-three-soba/vanilla-exports';
import * as i0 from "@angular/core";
export interface NgtsMeshDistortMaterialOptions extends Partial<MeshDistortMaterialParameters>, Partial<NgtMeshPhysicalMaterial> {
    speed: number;
    factor?: number;
}
export declare class NgtsMeshDistortMaterial {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMeshDistortMaterialOptions, "" | Partial<NgtsMeshDistortMaterialOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsMeshDistortMaterialOptions, "speed">>;
    material: MeshDistortMaterial;
    private speed;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMeshDistortMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMeshDistortMaterial, "ngts-mesh-distort-material", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
