import { ElementRef, Injector, WritableSignal } from '@angular/core';
import { Object3D } from 'three';
import * as i0 from "@angular/core";
export declare function injectIntersect<TObject extends Object3D>(object: () => ElementRef<TObject> | TObject | undefined | null, { injector, source }?: {
    injector?: Injector;
    source?: WritableSignal<boolean>;
}): import("@angular/core").Signal<boolean>;
export declare class NgtsIntersect {
    intersect: import("@angular/core").ModelSignal<boolean>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsIntersect, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsIntersect, "[intersect]", never, { "intersect": { "alias": "intersect"; "required": false; "isSignal": true; }; }, { "intersect": "intersectChange"; }, never, never, true, never>;
}
