import { ElementRef } from '@angular/core';
import { NgtLOD } from 'angular-three';
import { LOD } from 'three';
import * as i0 from "@angular/core";
export interface NgtsDetailedOptions extends Partial<NgtLOD> {
    hysteresis: number;
}
export declare class NgtsDetailed {
    distances: import("@angular/core").InputSignal<number[]>;
    options: import("@angular/core").InputSignalWithTransform<NgtsDetailedOptions, "" | Partial<NgtsDetailedOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsDetailedOptions, "hysteresis">>;
    lodRef: import("@angular/core").Signal<ElementRef<LOD<import("three").Object3DEventMap>>>;
    private hysteresis;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsDetailed, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsDetailed, "ngts-detailed", never, { "distances": { "alias": "distances"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
