import { ElementRef } from '@angular/core';
import { NgtInstancedMesh } from 'angular-three';
import { InstancedMesh, Matrix4, Quaternion, Vector3 } from 'three';
import { PositionMesh } from './position-mesh';
import * as i0 from "@angular/core";
export declare class NgtsInstance {
    options: import("@angular/core").InputSignal<Partial<{
        color?: import("three").ColorRepresentation | undefined;
        name?: string | undefined;
        visible?: boolean | undefined;
        userData?: Record<string, any> | undefined;
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionMesh, typeof PositionMesh>, ev: import("angular-three").NgtNodeEventMap<PositionMesh>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionMesh, typeof PositionMesh>, ev: import("angular-three").NgtNodeEventMap<PositionMesh>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        instance?: ElementRef<InstancedMesh> | InstancedMesh | null | undefined;
        readonly geometry?: import("three").BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: import("three").BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: import("three").BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: Quaternion) => PositionMesh) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => PositionMesh) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => PositionMesh) | undefined;
        rotateX?: ((angle: number) => PositionMesh) | undefined;
        rotateY?: ((angle: number) => PositionMesh) | undefined;
        rotateZ?: ((angle: number) => PositionMesh) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => PositionMesh) | undefined;
        translateX?: ((distance: number) => PositionMesh) | undefined;
        translateY?: ((distance: number) => PositionMesh) | undefined;
        translateZ?: ((distance: number) => PositionMesh) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => PositionMesh) | undefined;
        remove?: ((...object: import("three").Object3D[]) => PositionMesh) | undefined;
        removeFromParent?: (() => PositionMesh) | undefined;
        clear?: (() => PositionMesh) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: Quaternion) => Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => PositionMesh) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => PositionMesh) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, PositionMesh>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }>>;
    instances: NgtsInstances;
    positionMeshRef: import("@angular/core").Signal<ElementRef<PositionMesh>>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsInstance, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsInstance, "ngts-instance", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
export interface NgtsInstancesOptions extends Partial<NgtInstancedMesh> {
    range?: number;
    limit: number;
    frames: number;
}
export declare class NgtsInstances {
    protected readonly DynamicDrawUsage: 35048;
    options: import("@angular/core").InputSignalWithTransform<NgtsInstancesOptions, "" | Partial<NgtsInstancesOptions>>;
    protected parameters: import("@angular/core").Signal<Omit<NgtsInstancesOptions, "limit" | "range" | "frames">>;
    instancedMeshRef: import("@angular/core").Signal<ElementRef<InstancedMesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").InstancedMeshEventMap>>>;
    private limit;
    protected buffers: import("@angular/core").Signal<{
        matrices: Float32Array<ArrayBuffer>;
        colors: Float32Array<ArrayBuffer>;
    }>;
    instances: Array<ElementRef<PositionMesh> | PositionMesh>;
    constructor();
    subscribe(ref: ElementRef<PositionMesh> | PositionMesh): () => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsInstances, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsInstances, "ngts-instances", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
