import { ElementRef } from '@angular/core';
import { NgtPoints } from 'angular-three';
import { BufferGeometry, Matrix4, Points, Vector3 } from 'three';
import { PositionPoint } from './position-point';
import * as i0 from "@angular/core";
export declare class NgtsPoint {
    options: import("@angular/core").InputSignal<Partial<{
        color?: import("three").ColorRepresentation | undefined;
        name?: string | undefined;
        visible?: boolean | undefined;
        userData?: Record<string, any> | undefined;
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionPoint, typeof PositionPoint>, ev: import("angular-three").NgtNodeEventMap<PositionPoint>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionPoint, typeof PositionPoint>, ev: import("angular-three").NgtNodeEventMap<PositionPoint>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        size?: number | undefined;
        instance?: ElementRef<Points> | Points | null | undefined;
        readonly geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => PositionPoint) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => PositionPoint) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => PositionPoint) | undefined;
        rotateX?: ((angle: number) => PositionPoint) | undefined;
        rotateY?: ((angle: number) => PositionPoint) | undefined;
        rotateZ?: ((angle: number) => PositionPoint) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => PositionPoint) | undefined;
        translateX?: ((distance: number) => PositionPoint) | undefined;
        translateY?: ((distance: number) => PositionPoint) | undefined;
        translateZ?: ((distance: number) => PositionPoint) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => PositionPoint) | undefined;
        remove?: ((...object: import("three").Object3D[]) => PositionPoint) | undefined;
        removeFromParent?: (() => PositionPoint) | undefined;
        clear?: (() => PositionPoint) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => PositionPoint) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => PositionPoint) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, PositionPoint>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }>>;
    positionPointRef: import("@angular/core").Signal<ElementRef<PositionPoint>>;
    points: NgtsPointsInstances;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsPoint, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsPoint, "ngts-point", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
export declare class NgtsPointsBuffer {
    positions: import("@angular/core").InputSignal<Float32Array<ArrayBufferLike>>;
    colors: import("@angular/core").InputSignal<Float32Array<ArrayBufferLike> | undefined>;
    sizes: import("@angular/core").InputSignal<Float32Array<ArrayBufferLike> | undefined>;
    stride: import("@angular/core").InputSignal<3 | 2>;
    options: import("@angular/core").InputSignal<Partial<{
        color?: import("three").ColorRepresentation | undefined;
        name?: string | undefined;
        visible?: boolean | undefined;
        userData?: Record<string, any> | undefined;
        addEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionPoint, typeof PositionPoint>, ev: import("angular-three").NgtNodeEventMap<PositionPoint>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        removeEventListener: (<TEventKey extends keyof import("angular-three").NgtNodeEventMap<TOriginal>>(type: TEventKey, listener: (this: import("angular-three").NgtNodeElement<PositionPoint, typeof PositionPoint>, ev: import("angular-three").NgtNodeEventMap<PositionPoint>[TEventKey]) => any) => void) & (<TEventKey extends keyof import("angular-three").NgtAllObject3DEventsMap>(type: TEventKey, listener: (this: /*elided*/ any, ev: import("angular-three").NgtAllObject3DEventsMap[TEventKey]) => any) => void);
        attach: string | string[] | import("angular-three").NgtAttachFunction;
        __ngt_args__: [];
        size?: number | undefined;
        instance?: ElementRef<Points> | Points | null | undefined;
        readonly geometry?: BufferGeometry<import("three").NormalBufferAttributes> | undefined;
        readonly isGroup?: true | undefined;
        readonly isObject3D?: true | undefined;
        readonly id?: number | undefined;
        uuid?: string | undefined;
        readonly type?: string | undefined;
        parent?: import("three").Object3D<import("three").Object3DEventMap> | null | undefined;
        children?: import("three").Object3D<import("three").Object3DEventMap>[] | undefined;
        readonly modelViewMatrix?: Matrix4 | undefined;
        readonly normalMatrix?: import("three").Matrix3 | undefined;
        matrixWorld?: Matrix4 | undefined;
        matrixAutoUpdate?: boolean | undefined;
        matrixWorldAutoUpdate?: boolean | undefined;
        matrixWorldNeedsUpdate?: boolean | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        animations?: import("three").AnimationClip[] | undefined;
        customDepthMaterial?: import("three").Material | undefined;
        customDistanceMaterial?: import("three").Material | undefined;
        onBeforeShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterShadow?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, shadowCamera: import("three").Camera, geometry: BufferGeometry, depthMaterial: import("three").Material, group: import("three").Group) => void) | undefined;
        onBeforeRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        onAfterRender?: ((renderer: import("three").WebGLRenderer, scene: import("three").Scene, camera: import("three").Camera, geometry: BufferGeometry, material: import("three").Material, group: import("three").Group) => void) | undefined;
        applyMatrix4?: ((matrix: Matrix4) => void) | undefined;
        applyQuaternion?: ((quaternion: import("three").Quaternion) => PositionPoint) | undefined;
        setRotationFromAxisAngle?: ((axis: Vector3, angle: number) => void) | undefined;
        setRotationFromEuler?: ((euler: import("three").Euler) => void) | undefined;
        setRotationFromMatrix?: ((m: Matrix4) => void) | undefined;
        setRotationFromQuaternion?: ((q: import("three").Quaternion) => void) | undefined;
        rotateOnAxis?: ((axis: Vector3, angle: number) => PositionPoint) | undefined;
        rotateOnWorldAxis?: ((axis: Vector3, angle: number) => PositionPoint) | undefined;
        rotateX?: ((angle: number) => PositionPoint) | undefined;
        rotateY?: ((angle: number) => PositionPoint) | undefined;
        rotateZ?: ((angle: number) => PositionPoint) | undefined;
        translateOnAxis?: ((axis: Vector3, distance: number) => PositionPoint) | undefined;
        translateX?: ((distance: number) => PositionPoint) | undefined;
        translateY?: ((distance: number) => PositionPoint) | undefined;
        translateZ?: ((distance: number) => PositionPoint) | undefined;
        localToWorld?: ((vector: Vector3) => Vector3) | undefined;
        worldToLocal?: ((vector: Vector3) => Vector3) | undefined;
        lookAt?: {
            (vector: Vector3): void;
            (x: number, y: number, z: number): void;
        } | undefined;
        add?: ((...object: import("three").Object3D[]) => PositionPoint) | undefined;
        remove?: ((...object: import("three").Object3D[]) => PositionPoint) | undefined;
        removeFromParent?: (() => PositionPoint) | undefined;
        clear?: (() => PositionPoint) | undefined;
        getObjectById?: ((id: number) => import("three").Object3D | undefined) | undefined;
        getObjectByName?: ((name: string) => import("three").Object3D | undefined) | undefined;
        getObjectByProperty?: ((name: string, value: any) => import("three").Object3D | undefined) | undefined;
        getObjectsByProperty?: ((name: string, value: any, optionalTarget?: import("three").Object3D[]) => import("three").Object3D[]) | undefined;
        getWorldPosition?: ((target: Vector3) => Vector3) | undefined;
        getWorldQuaternion?: ((target: import("three").Quaternion) => import("three").Quaternion) | undefined;
        getWorldScale?: ((target: Vector3) => Vector3) | undefined;
        getWorldDirection?: ((target: Vector3) => Vector3) | undefined;
        traverse?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseVisible?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        traverseAncestors?: ((callback: (object: import("three").Object3D) => any) => void) | undefined;
        updateMatrix?: (() => void) | undefined;
        updateMatrixWorld?: ((force?: boolean) => void) | undefined;
        updateWorldMatrix?: ((updateParents: boolean, updateChildren: boolean) => void) | undefined;
        toJSON?: ((meta?: import("three").JSONMeta) => import("three").Object3DJSON) | undefined;
        clone?: ((recursive?: boolean) => PositionPoint) | undefined;
        copy?: ((object: import("three").Object3D, recursive?: boolean) => PositionPoint) | undefined;
        hasEventListener?: (<T extends keyof import("three").Object3DEventMap>(type: T, listener: import("three").EventListener<import("three").Object3DEventMap[T], T, PositionPoint>) => boolean) | undefined;
        dispatchEvent?: (<T extends keyof import("three").Object3DEventMap>(event: import("three").BaseEvent<T> & import("three").Object3DEventMap[T]) => void) | undefined;
        position: import("angular-three").NgtVector3;
        up: import("angular-three").NgtVector3;
        scale: import("angular-three").NgtVector3;
        rotation: import("angular-three").NgtEuler;
        matrix: import("angular-three").NgtMatrix4;
        quaternion: import("angular-three").NgtQuaternion;
        layers: import("angular-three").NgtLayers;
        dispose: (() => void) | null;
        raycast: import("three").Object3D["raycast"] | null;
    }>>;
    pointsRef: import("@angular/core").Signal<ElementRef<Points<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    constructor();
    protected readonly DynamicDrawUsage: 35048;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsPointsBuffer, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsPointsBuffer, "ngts-points-buffer", never, { "positions": { "alias": "positions"; "required": true; "isSignal": true; }; "colors": { "alias": "colors"; "required": false; "isSignal": true; }; "sizes": { "alias": "sizes"; "required": false; "isSignal": true; }; "stride": { "alias": "stride"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
export interface NgtsPointsInstancesOptions extends Partial<NgtPoints> {
    range?: number;
    limit: number;
}
export declare class NgtsPointsInstances {
    options: import("@angular/core").InputSignalWithTransform<NgtsPointsInstancesOptions, "" | Partial<NgtsPointsInstancesOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsPointsInstancesOptions, "limit" | "range">>;
    pointsRef: import("@angular/core").Signal<ElementRef<Points<BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    private limit;
    buffers: import("@angular/core").Signal<{
        positions: Float32Array<ArrayBuffer>;
        colors: Float32Array<ArrayBuffer>;
        sizes: Float32Array<ArrayBuffer>;
    }>;
    positionPoints: Array<ElementRef<PositionPoint> | PositionPoint>;
    constructor();
    subscribe(ref: ElementRef<PositionPoint> | PositionPoint): () => void;
    protected readonly DynamicDrawUsage: 35048;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsPointsInstances, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsPointsInstances, "ngts-points-instances", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
