import { NgtNode } from 'angular-three';
import { Color, Vector3 } from 'three';
export type NgtSegmentObject = NgtNode<SegmentObject, typeof SegmentObject>;
export declare class SegmentObject {
    color: Color;
    start: Vector3;
    end: Vector3;
    constructor();
}
declare global {
    interface HTMLElementTagNameMap {
        /**
         * @rawOptions start|color|end
         */
        'ngt-segment-object': NgtSegmentObject;
    }
}
