import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group, PlaneGeometry } from 'three';
import * as i0 from "@angular/core";
export interface NgtsBackdropOptions extends Partial<NgtGroup> {
    floor: number;
    segments: number;
    receiveShadow?: boolean;
}
export declare class NgtsBackdrop {
    protected readonly Math: Math;
    options: import("@angular/core").InputSignalWithTransform<NgtsBackdropOptions, "" | Partial<NgtsBackdropOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsBackdropOptions, "receiveShadow" | "floor" | "segments">>;
    groupRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    planeRef: import("@angular/core").Signal<ElementRef<PlaneGeometry> | undefined>;
    receiveShadow: import("@angular/core").Signal<boolean | undefined>;
    segments: import("@angular/core").Signal<number>;
    private floor;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsBackdrop, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsBackdrop, "ngts-backdrop", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
