import * as i0 from "@angular/core";
export interface NgtsCameraShakeOptions {
    intensity: number;
    decay?: boolean;
    decayRate: number;
    maxYaw: number;
    maxPitch: number;
    maxRoll: number;
    yawFrequency: number;
    pitchFrequency: number;
    rollFrequency: number;
}
export declare class NgtsCameraShake {
    options: import("@angular/core").InputSignalWithTransform<NgtsCameraShakeOptions, "" | Partial<NgtsCameraShakeOptions>>;
    private store;
    private camera;
    private defaultControls;
    private initialRotation;
    private intensityOption;
    get intensity(): number;
    set intensity(val: number);
    private yawNoise;
    private pitchNoise;
    private rollNoise;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCameraShake, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsCameraShake, "ngts-camera-shake", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
