import { ElementRef } from '@angular/core';
import { NgtGroup } from 'angular-three';
import { Group } from 'three';
import * as i0 from "@angular/core";
export interface NgtsFloatOptions extends Partial<NgtGroup> {
    enabled: boolean;
    speed: number;
    rotationIntensity: number;
    floatIntensity: number;
    floatingRange: [number?, number?];
    autoInvalidate: boolean;
}
export declare class NgtsFloat {
    options: import("@angular/core").InputSignalWithTransform<NgtsFloatOptions, "" | Partial<NgtsFloatOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsFloatOptions, "enabled" | "speed" | "rotationIntensity" | "floatIntensity" | "floatingRange" | "autoInvalidate">>;
    floatRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsFloat, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsFloat, "ngts-float", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
