import { Injector, Signal } from '@angular/core';
import { Texture } from 'three';
import * as i0 from "@angular/core";
interface NgtsNormalTextureSettings {
    repeat?: number[];
    anisotropy?: number;
    offset?: number[];
}
export declare function injectNormalTexture(id: (() => string | number) | undefined, { settings, onLoad, injector, }: {
    settings?: () => NgtsNormalTextureSettings;
    onLoad?: (texture: Texture[]) => void;
    injector?: Injector;
}): {
    url: Signal<string>;
    texture: Signal<Texture | null>;
    numTot: Signal<number>;
};
export interface NgtsNormalTextureOptions extends NgtsNormalTextureSettings {
    id?: number | string;
}
export declare class NgtsNormalTexture {
    normalTexture: import("@angular/core").InputSignal<NgtsNormalTextureOptions | undefined>;
    normalTextureLoaded: import("@angular/core").OutputEmitterRef<Texture[]>;
    private template;
    private vcr;
    private id;
    private settings;
    private ref?;
    constructor();
    static ngTemplateContextGuard(_: NgtsNormalTexture, ctx: unknown): ctx is {
        $implicit: Signal<Texture | null>;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsNormalTexture, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsNormalTexture, "ng-template[normalTexture]", never, { "normalTexture": { "alias": "normalTexture"; "required": false; "isSignal": true; }; }, { "normalTextureLoaded": "normalTextureLoaded"; }, never, never, true, never>;
}
export {};
