import { NgtAttachable, NgtTexture } from 'angular-three';
import { ColorRepresentation } from 'three';
import * as i0 from "@angular/core";
export interface NgtsGradientTextureOptions extends Partial<Omit<NgtTexture, 'type'>> {
    size: number;
    width: number;
    type: 'linear' | 'radial';
    innerCircleRadius: number;
    outerCircleRadius: string | number;
}
export declare class NgtsGradientTexture {
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    stops: import("@angular/core").InputSignal<number[]>;
    colors: import("@angular/core").InputSignal<ColorRepresentation[]>;
    options: import("@angular/core").InputSignalWithTransform<NgtsGradientTextureOptions, "" | Partial<NgtsGradientTextureOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsGradientTextureOptions, "type" | "size" | "width" | "innerCircleRadius" | "outerCircleRadius">>;
    private store;
    outputColorSpace: import("@angular/core").Signal<string>;
    private document;
    canvas: import("@angular/core").Signal<HTMLCanvasElement>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsGradientTexture, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsGradientTexture, "ngts-gradient-texture", never, { "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "stops": { "alias": "stops"; "required": true; "isSignal": true; }; "colors": { "alias": "colors"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
