import { NgtCamera } from 'angular-three';
import CameraControls from 'camera-controls';
import * as i0 from "@angular/core";
export interface NgtsCameraControlsOptions {
    camera?: NgtCamera;
    domElement?: HTMLElement;
    makeDefault: boolean;
    events: boolean;
    regress: boolean;
}
export declare class NgtsCameraControls {
    options: import("@angular/core").InputSignalWithTransform<Partial<CameraControls> & NgtsCameraControlsOptions, "" | Partial<Partial<CameraControls> & NgtsCameraControlsOptions>>;
    parameters: import("@angular/core").Signal<Omit<Partial<CameraControls> & NgtsCameraControlsOptions, "domElement" | "makeDefault" | "camera" | "regress">>;
    changed: import("@angular/core").OutputEmitterRef<any>;
    started: import("@angular/core").OutputEmitterRef<any>;
    ended: import("@angular/core").OutputEmitterRef<any>;
    private store;
    private invalidate;
    private performanceRegress;
    private defaultCamera;
    private glDomElement;
    private eventsElement;
    private camera;
    private regress;
    private domElement;
    private makeDefault;
    controls: import("@angular/core").Signal<CameraControls>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCameraControls, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsCameraControls, "ngts-camera-controls", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "changed": "changed"; "started": "started"; "ended": "ended"; }, never, ["*"], true, never>;
}
