import { NgtVector3 } from 'angular-three';
import { Camera, Event } from 'three';
import { OrbitControls } from 'three-stdlib';
import * as i0 from "@angular/core";
export interface NgtsOrbitControlsOptions {
    camera?: Camera;
    domElement?: HTMLElement;
    target?: NgtVector3;
    makeDefault: boolean;
    regress: boolean;
    enableDamping: boolean;
    keyEvents: boolean | HTMLElement;
}
export declare class NgtsOrbitControls {
    options: import("@angular/core").InputSignalWithTransform<Partial<OrbitControls> & NgtsOrbitControlsOptions, "" | Partial<Partial<OrbitControls> & NgtsOrbitControlsOptions>>;
    parameters: import("@angular/core").Signal<Omit<Partial<OrbitControls> & NgtsOrbitControlsOptions, "domElement" | "enableDamping" | "makeDefault" | "camera" | "regress" | "keyEvents">>;
    changed: import("@angular/core").OutputEmitterRef<Event<string, unknown>>;
    started: import("@angular/core").OutputEmitterRef<Event<string, unknown>>;
    ended: import("@angular/core").OutputEmitterRef<Event<string, unknown>>;
    private store;
    private invalidate;
    private performanceRegress;
    private defaultCamera;
    private glDomElement;
    private camera;
    private regress;
    private keyEvents;
    private domElement;
    private makeDefault;
    controls: import("@angular/core").Signal<OrbitControls>;
    protected enableDamping: import("@angular/core").Signal<boolean>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsOrbitControls, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsOrbitControls, "ngts-orbit-controls", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, { "changed": "changed"; "started": "started"; "ended": "ended"; }, never, ["*"], true, never>;
}
