import { Injector } from '@angular/core';
import { Font } from 'three-stdlib';
export type Glyph = {
    _cachedOutline: string[];
    ha: number;
    o: string;
};
export type FontData = {
    boundingBox: {
        yMax: number;
        yMin: number;
    };
    familyName: string;
    glyphs: {
        [k: string]: Glyph;
    };
    resolution: number;
    underlineThickness: number;
};
export type NgtsFontInput = string | FontData;
export declare function injectFont(input: () => NgtsFontInput, { injector }?: {
    injector?: Injector;
}): import("@angular/core").Signal<Font | null>;
export declare namespace injectFont {
    var preload: (input: () => NgtsFontInput) => void;
    var clear: (input?: () => NgtsFontInput) => void;
}
