import { ElementRef } from '@angular/core';
import { NgtAttachable } from 'angular-three';
import { Material } from 'three';
import CustomShaderMaterial from 'three-custom-shader-material/vanilla';
import * as i0 from "@angular/core";
export declare class NgtsCustomShaderMaterial {
    baseMaterial: import("@angular/core").InputSignal<typeof Material | Material | ElementRef<Material>>;
    attach: import("@angular/core").InputSignal<NgtAttachable>;
    options: import("@angular/core").InputSignal<Omit<any, "baseMaterial">>;
    parameters: import("@angular/core").Signal<Omit<Omit<any, "baseMaterial">, "uniforms" | "vertexShader" | "fragmentShader" | "cacheKey">>;
    private base;
    private fragmentShader;
    private vertexShader;
    private uniforms;
    private cacheKey;
    material: import("@angular/core").Signal<CustomShaderMaterial<import("three-custom-shader-material/vanilla").MaterialConstructor>>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsCustomShaderMaterial, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsCustomShaderMaterial, "ngts-custom-shader-material", never, { "baseMaterial": { "alias": "baseMaterial"; "required": true; "isSignal": true; }; "attach": { "alias": "attach"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
