import { ElementRef } from '@angular/core';
import { BufferAttribute, BufferGeometry } from 'three';
import * as i0 from "@angular/core";
export declare class NgtsComputedAttribute {
    compute: import("@angular/core").InputSignal<(geometry: BufferGeometry) => BufferAttribute>;
    name: import("@angular/core").InputSignal<string>;
    options: import("@angular/core").InputSignal<Partial<import("angular-three").NgtExtendedColors<import("angular-three").NgtOverwrite<Partial<{
        set: (value: ArrayLike<number> | ArrayBufferView, offset?: number) => BufferAttribute;
        name: string;
        applyMatrix4: (m: import("three").Matrix4) => BufferAttribute;
        toJSON: () => import("three").BufferAttributeJSON;
        clone: () => BufferAttribute;
        copy: (source: BufferAttribute) => BufferAttribute;
        readonly count: number;
        array: import("three").TypedArray;
        itemSize: number;
        usage: import("three").Usage;
        gpuType: import("three").AttributeGPUType;
        updateRanges: Array<{
            start: number;
            count: number;
        }>;
        version: number;
        normalized: boolean;
        needsUpdate: boolean;
        readonly isBufferAttribute: true;
        onUploadCallback: () => void;
        onUpload: (callback: () => void) => BufferAttribute;
        setUsage: (usage: import("three").Usage) => BufferAttribute;
        addUpdateRange: (start: number, count: number) => void;
        clearUpdateRanges: () => void;
        copyAt: (index1: number, attribute: BufferAttribute, index2: number) => BufferAttribute;
        copyArray: (array: ArrayLike<number>) => BufferAttribute;
        applyMatrix3: (m: import("three").Matrix3) => BufferAttribute;
        applyNormalMatrix: (m: import("three").Matrix3) => BufferAttribute;
        transformDirection: (m: import("three").Matrix4) => BufferAttribute;
        getComponent: (index: number, component: number) => number;
        setComponent: (index: number, component: number, value: number) => void;
        getX: (index: number) => number;
        setX: (index: number, x: number) => BufferAttribute;
        getY: (index: number) => number;
        setY: (index: number, y: number) => BufferAttribute;
        getZ: (index: number) => number;
        setZ: (index: number, z: number) => BufferAttribute;
        getW: (index: number) => number;
        setW: (index: number, z: number) => BufferAttribute;
        setXY: (index: number, x: number, y: number) => BufferAttribute;
        setXYZ: (index: number, x: number, y: number, z: number) => BufferAttribute;
        setXYZW: (index: number, x: number, y: number, z: number, w: number) => BufferAttribute;
    }>, import("angular-three").NgtNodeElement<BufferAttribute, typeof BufferAttribute>>>>>;
    bufferAttribute: BufferAttribute;
    attributeRef: import("@angular/core").Signal<ElementRef<BufferAttribute> | undefined>;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsComputedAttribute, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsComputedAttribute, "ngts-computed-attribute", never, { "compute": { "alias": "compute"; "required": true; "isSignal": true; }; "name": { "alias": "name"; "required": true; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
