import { ElementRef } from '@angular/core';
import { NgtMesh } from 'angular-three';
import { Mesh, Texture } from 'three';
import * as i0 from "@angular/core";
export interface NgtsDecalOptions extends Partial<NgtMesh> {
    polygonOffsetFactor: number;
    depthTest: boolean;
    debug: boolean;
    map?: Texture | null;
}
export declare class NgtsDecal {
    mesh: import("@angular/core").InputSignal<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap> | ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>> | null | undefined>;
    options: import("@angular/core").InputSignalWithTransform<NgtsDecalOptions, "" | Partial<NgtsDecalOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsDecalOptions, "position" | "scale" | "rotation" | "debug" | "map" | "depthTest" | "polygonOffsetFactor">>;
    meshRef: import("@angular/core").Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>>>;
    helperRef: import("@angular/core").Signal<ElementRef<Mesh<import("three").BufferGeometry<import("three").NormalBufferAttributes>, import("three").Material | import("three").Material[], import("three").Object3DEventMap>> | undefined>;
    protected map: import("@angular/core").Signal<Texture | null | undefined>;
    protected depthTest: import("@angular/core").Signal<boolean>;
    protected polygonOffsetFactor: import("@angular/core").Signal<number>;
    protected debug: import("@angular/core").Signal<boolean>;
    private position;
    private rotation;
    private scale;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsDecal, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsDecal, "ngts-decal", never, { "mesh": { "alias": "mesh"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
