import { BufferAttribute } from 'three';
/**
 * NOTE: Sets `BufferAttribute.updateRange` since r159.
 */
export declare const setUpdateRange: (attribute: BufferAttribute, updateRange: {
    offset: number;
    count: number;
}) => void;
export declare const LinearEncoding = 3000;
export declare const sRGBEncoding = 3001;
/**
 * NOTE: TextureEncoding was deprecated in r152, and removed in r162.
 */
export type TextureEncoding = typeof LinearEncoding | typeof sRGBEncoding;
