import { ElementRef } from '@angular/core';
import { NgtObject3DNode } from 'angular-three';
import { BufferGeometry, Color, Group, InstancedMesh, Intersection, Raycaster } from 'three';
export type NgtPositionMesh = NgtObject3DNode<PositionMesh, typeof PositionMesh>;
export declare class PositionMesh extends Group {
    color: Color;
    instance: ElementRef<InstancedMesh> | InstancedMesh | null | undefined;
    constructor();
    get geometry(): BufferGeometry<import("three").NormalBufferAttributes> | undefined;
    raycast(raycaster: Raycaster, intersects: Intersection[]): void;
}
declare global {
    interface HTMLElementTagNameMap {
        /**
         * @extends ngt-group
         * @rawOptions instance|color
         */
        'ngt-position-mesh': NgtPositionMesh;
    }
}
