import { ElementRef } from '@angular/core';
import { NgtGroup, NgtVector3 } from 'angular-three';
import { Group, Object3D } from 'three';
import * as i0 from "@angular/core";
export interface NgtsBBAnchorOptions extends Partial<NgtGroup> {
    anchor: NgtVector3;
}
export declare class NgtsBBAnchor {
    options: import("@angular/core").InputSignal<NgtsBBAnchorOptions>;
    parameters: import("@angular/core").Signal<Omit<NgtsBBAnchorOptions, "anchor">>;
    bbAnchorRef: import("@angular/core").Signal<ElementRef<Group<import("three").Object3DEventMap>>>;
    parent: import("@angular/core").WritableSignal<Object3D<import("three").Object3DEventMap> | null>;
    private anchor;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsBBAnchor, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsBBAnchor, "ngts-bb-anchor", never, { "options": { "alias": "options"; "required": true; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
