import { ElementRef, Injector } from '@angular/core';
import { NgtMesh } from 'angular-three';
import { BufferGeometry, Material, Mesh } from 'three';
import * as i0 from "@angular/core";
export interface NgtsMaskOptions extends Partial<NgtMesh> {
    colorWrite: boolean;
    depthWrite: boolean;
}
export declare class NgtsMask {
    id: import("@angular/core").InputSignalWithTransform<number, unknown>;
    options: import("@angular/core").InputSignalWithTransform<NgtsMaskOptions, "" | Partial<NgtsMaskOptions>>;
    parameters: import("@angular/core").Signal<Omit<NgtsMaskOptions, "depthWrite" | "colorWrite">>;
    meshRef: import("@angular/core").Signal<ElementRef<Mesh<BufferGeometry<import("three").NormalBufferAttributes>, Material, import("three").Object3DEventMap>>>;
    private colorWrite;
    private depthWrite;
    private spread;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMask, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtsMask, "ngts-mask", never, { "id": { "alias": "id"; "required": false; "isSignal": true; }; "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, never, ["*"], true, never>;
}
export declare function injectMask(id: () => number, inverse?: () => boolean, { injector }?: {
    injector?: Injector;
}): import("@angular/core").Signal<{
    stencilWrite: boolean;
    stencilRef: number;
    stencilFunc: 517 | 514;
    stencilFail: 7680;
    stencilZFail: 7680;
    stencilZPass: 7680;
}>;
