import { Injector, Signal } from '@angular/core';
import { Texture } from 'three';
import * as i0 from "@angular/core";
export declare function injectMatcapTexture(id?: () => number | string, { format, onLoad, injector, }?: {
    format?: () => number;
    onLoad?: (texture: Texture[]) => void;
    injector?: Injector;
}): {
    url: Signal<string>;
    texture: Signal<Texture | null>;
    numTot: Signal<number>;
};
export interface NgtsMatcapTextureOptions {
    id?: number | string;
    format?: number;
}
export declare class NgtsMatcapTexture {
    matcapTexture: import("@angular/core").InputSignal<NgtsMatcapTextureOptions | undefined>;
    matcapTextureLoaded: import("@angular/core").OutputEmitterRef<Texture[]>;
    private template;
    private vcr;
    private id;
    private format;
    private ref?;
    constructor();
    static ngTemplateContextGuard(_: NgtsMatcapTexture, ctx: unknown): ctx is {
        $implicit: Signal<Texture | null>;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtsMatcapTexture, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtsMatcapTexture, "ng-template[matcapTexture]", never, { "matcapTexture": { "alias": "matcapTexture"; "required": false; "isSignal": true; }; }, { "matcapTextureLoaded": "matcapTextureLoaded"; }, never, never, true, never>;
}
